extern    printf
extern    scanf

section .data
    fmt_number: db "%d", 0
    fmt_prompt: db "Type a number, -1 to terminate: ", 0
    fmt_result_positive: db "The string is palindrome", 10, 0
    fmt_result_negative: db "The string is not palindrome", 10, 0
    len: dd 0

section .bss
    num: resd 1
    res: resd 1
    
section .text
    global main

main:
    push ebp
    mov  ebp, esp

loop:
    ; Print promp
    push dword fmt_prompt
    call printf
    add  esp, 4
    
    ; Read num
    push dword num
    push dword fmt_number
    call scanf
    add  esp, 4*2
    
    ; Push number in the stack, and increase length of the sequence
    push dword [num]
    inc dword [len]
    
    cmp [num], dword -1
    jne loop

    ; Remove the guard
    pop eax
    dec dword [len]

    mov [res], dword fmt_result_positive    ; res = palindrome
    lea esi, [esp]              ; Pointer to the last number
    lea edi, [ebp - 4]          ; Pointer to the first number
    mov ecx, [len]              ; Counter for the loop
check:
    ; If the pointed numbers are different, res = non-palindrome
    mov eax, [esi]
    cmp eax, [edi]
    je continue
    mov [res], dword fmt_result_negative
    jmp print

continue:    
    ; Next pair of numbers to be checked
    add esi, 4
    sub edi, 4
    
    loop check
    
print:
    push dword [res]
    call printf
    add esp, 4*2

    mov  eax, 0
    leave
    ret
    
